/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/*
 * interactive trellis checker
 * needs trellis visualization (TRELLIS_VISUALIZE)
 */

#include <julius.h>

#ifdef TRELLIS_VISUALIZE

static WORD_ID wlistid[100], wlistnum; /* $B6/D4I=<(Cf$NC18l%j%9%H(B */
static WORD_ID wpathid[100], wpathnum; /* $B6/D4I=<(Cf$N%Q%9%j%9%H(B */

/* $B%H%l%j%9$NBPOCE*%A%'%C%/(B */
#ifdef WPAIR
/* $B@5>o$KF0$+$J$$2DG=@-$"$j!JL$3NG'!K(B */
#endif
void
check_trellis(BACKTRELLIS *backtrellis, int framelen)
{
  char *buf;
  WORD_ID word;
  int t,i;
  TRELLIS_ATOM *ta;
  char cmd[80];
  char *arg;

  wlistnum = 0;
  wpathnum = 0;
  
  for (;;) {
    j_flushprint();
    buf = get_line("Enter command: (w arg|p arg|clear)\n--- arg ::= wname or wname[woutput] or #wid\n>");
    if (buf == NULL) break;
    if (strlen(buf) == 0) break;

    strcpy(cmd, strtok(buf, " \t\n"));
    arg = strtok(NULL, " \t\n");

    if (strmatch(cmd, "w")) { /* highlight the word in all backtrellis */
      if (arg == NULL) {
	j_printf("words now highlighted:\n");
	for (i=0;i<wlistnum;i++) {
	  put_voca(&winfo, wlistid[i]);
	}
      } else {
	word = voca_lookup_wid(arg, &winfo);
	if (word == WORD_INVALID) {
	  j_printf("no word named \"%s\"\n", arg);
	} else {
	  put_voca(&winfo, word);
	  for (t=0;t<framelen; t++) {
	    ta = bt_binsearch_atom(backtrellis, t, word);
	    if (ta != NULL) {
	      TrevisPutWord(ta, t, 2, backtrellis);
	    }
	  }
	  wlistid[wlistnum++] = word; /* store wid currentry highlighted */
	}
      }
    } else if (strmatch(cmd, "p")) { /* put word path */
      if (arg == NULL) {
	j_printf("word paths highlighted which begin with:\n");
	for (i=0;i<wpathnum;i++) {
	  put_voca(&winfo, wpathid[i]);
	}
      } else {
	word = voca_lookup_wid(arg, &winfo);
	if (word == WORD_INVALID) {
	  j_printf("no word named \"%s\"\n", arg);
	} else {
	  put_voca(&winfo, word);
	  for (t=framelen-1;t>=0; t--) {
	    ta = bt_binsearch_atom(backtrellis, t, word);
	    if (ta != NULL) {
	      TrevisPutPathTrail(ta, t, backtrellis, 2, 1);
	    }
	    j_printf("--------------------------\n");
	  }
	  wpathid[wpathnum++] = word; /* store wid currentry highlighted */
	}
      }
    } else if (strmatch(cmd, "clear")) { /* clear wlist */
      for (i=0;i<wlistnum;i++) {
	word = wlistid[i];
	for (t=0;t<framelen; t++) {
	  ta = bt_binsearch_atom(backtrellis, t, word);
	  if (ta != NULL) {
	    TrevisPutWord(ta, t, 0, backtrellis);
	  }
	}
      }
      wlistnum = 0;
      for (i=0;i<wpathnum;i++) {
	word = wpathid[i];
	for (t=0;t<framelen; t++) {
	  ta = bt_binsearch_atom(backtrellis, t, word);
	  if (ta != NULL) {
	    TrevisPutPathTrail(ta, t, backtrellis, 0, 1);
	  }
	}
      }
      wpathnum = 0;
    }
    free(buf);
  }
}


#endif /* TRELLIS_VISUALIZE */
