/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* define.h --- define some internal compile options */

/************************************************************/
/********** DO NOT MODIFY MANUALLY DEFINES BELOW ************/
/************************************************************/
#define USE_NGRAM

#if defined(SCAN_BEAM_1) || defined(SCAN_BEAM_2)
#define SCAN_BEAM
#endif


/* abbreviations */
#define VERMES if (verbose_flag) j_printerr



/*** tree construction ***/
/* With 1-best approximation, Constructing a single tree from all words
   causes much error by factoring.  Listing each word flatly with no
   tree-organization will not cause this error, but the network becomes
   much larger and, especially, the inter-word LM handling becomes much more
   complex (O(n^2)).  The cost may be eased by LM caching, but it needs much
   memory. */
/* This is a trade-off of accuracy and cost */
#define SHORT_WORD_LEN 2
#ifdef LOWMEM
/* don't separate, construct a single tree from all words */
/* root nodes are about 50 in monophone, cache size will be 5MB on max */
#define NO_SEPARATE_SHORT_WORD
#else
#ifdef LOWMEM2
/* experimental: separate words frequently appears in corpus (1-gram) */
/* root nodes will be "-sepnum num" + 50, cache size will be 10MB or so */
#define NO_SEPARATE_SHORT_WORD
#define SEPARATE_BY_UNIGRAM
#define DEFAULT_SEPARATE_WNUM 150
#else
/* separate all short words (<= 2 phonemes) */
/* root nodes are about 1100 in 20k (proportional to vocabulary),
   cache size will be about 100MB on max */
#endif /* LOWMEM2 */
#endif /* LOWMEM */

/*#define HASH_CACHE_IW*/
/* "./configure --enable-lowmem" defines NO_SEPARATE_SHORT_WORD instead */


/* disable X11 related features if no X11 libraries are found */
#ifdef X_DISPLAY_MISSING
# ifdef TRELLIS_VISUALIZE
# undef TRELLIS_VISUALIZE
# endif
#endif /* X_DISPLAY_MISSING */


/*
 *   TEMPORARY definition for development
 *
 */
/*#undef DISCOUNT_BACKSCORE*/
#undef FIX_PENALTY


/* enable fancy cursor animation while recognizing... */
#undef FANCY_INDICATOR
