#include <sent/stddefs.h>
#include <sent/ptree.h>

static PATNODE *root = NULL;

#define MAXSTEP 100000
static int num;
static int maxlen;
static char **input = NULL;

static void
input_init()
{
  num = 0;
  maxlen = MAXSTEP;
  input = (char **)mymalloc(sizeof(char *) * maxlen);
}
static void
input_expand()
{
  maxlen += MAXSTEP;
  input = (char **)myrealloc(input, sizeof(char *) * maxlen);
}
static void
disp_all(PATNODE *node)
{
  int i;

  if (node->left0 == NULL && node->right1 == NULL) {
    printf("%s", input[node->value.data]);
  } else {
    if (node->left0 != NULL) {
      disp_all(node->left0);
    }
    if (node->right1 != NULL) {
      disp_all(node->right1);
    }
  }
}
static char buf[4096];
static void
reading(FILE *fp)
{
  int resid;
  if (input == NULL) input_init();
  while(fgets(buf, 4096, fp) != NULL) {
    if (root == NULL) {
      root = ptree_make_root_node(num);
      input[num] = strdup(buf);
      num++;
      if (num >= maxlen) input_expand();
    } else {
      resid = ptree_search_data(buf, root);
      if (strcmp(buf, input[resid]) == 0) {
	fprintf(stderr,"line %d is same as %d: %s", num+1, resid+1, buf);
      } else {
	ptree_add_entry(buf, num, input[resid], &root);	
	input[num] = strdup(buf);
	num++;
	if (num >= maxlen) input_expand();
      }
    }
  }
}

int main(int argc, char *argv[])
{
  int i;
  FILE *fp;

  root = NULL;

  if (argc > 1) {
    for(i=1;i<argc;i++) {
      fp = fopen_readfile(argv[i]);
      if (fp == NULL) {
	fprintf(stderr,"cannot open \"%s\"\n", argv[i]);
	return 1;
      }
      reading(fp);
      fclose_readfile(fp);
    }
  } else {
    reading(stdin);
  }
  disp_all(root);
  return 0;
}
      
