/* test ptree */

#include <sent/stddefs.h>
#include <sent/ptree.h>

PATNODE *root = NULL;
char name[100][256];

static void
disp_ptrees(PATNODE *node, int level)
{
  int i;

  for (i=0;i<level;i++) {
    j_printf("-");
  }
  if (node->left0 == NULL && node->right1 == NULL) {
    j_printf("data=%d[%s]\n", node->value.data, name[node->value.data]);
  } else {
    j_printf("%d\n", node->value.thres_bit);
    if (node->left0 != NULL) {
      disp_ptrees(node->left0, level+1);
    }
    if (node->right1 != NULL) {
      disp_ptrees(node->right1, level+1);
    }
  }
}

int main(int argc, char *argv[])
{
  char buf[256];
  int id = 0;
  int resid;
  
  while(1) {
    printf("enter any string > ");
    fflush(stdout);
    if (fgets(buf, 256, stdin) ==NULL) return 0;
    buf[strlen(buf)-1] = '\0';
    if (id == 0) {
      strcpy(name[id], buf);
      root = ptree_make_root_node(id);
      printf("make new root node\n");
      if (++id > 100) return 0;
      printf("-----\n");
      disp_ptrees(root, 0);
      printf("----- total: %d\n", id);
    } else {
      resid = ptree_search_data(buf, root);
      if (strcmp(buf, name[resid]) != 0) {
	printf("result don't match: %d:%s != %s\n", resid, name[resid],buf);
	ptree_add_entry(buf, id, name[resid], &root);
	printf("added to tree\n");
	strcpy(name[id], buf);
	if (++id > 100) return 0;
	printf("-----\n");
	disp_ptrees(root, 0);
	printf("----- total: %d\n", id);
      } else {
	printf("found id=%d\n", resid);
      }
    }

  }
} 
