/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* wav2mfcc.c --- call waveform to MFCC_E_D_Z converter */
/* $Id: wav2mfcc.c,v 1.1.1.1 1998/07/16 07:40:24 ri Exp $ */

#include <julius.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

HTK_Param *new_wav2mfcc(SP16 speech[], int speechlen)
{
  HTK_Param *param;
  Value para;			/* parameters for Wav2MFCC */
  int framenum;
  int i;

  para.smp_period = DEF_SMPPERIOD;
  para.framesize  = DEF_FRAMESIZE;
  para.frameshift = DEF_FRAMESHIFT;
  para.preEmph    = DEF_PREENPH;
  para.mfcc_dim   = DEF_MFCCDIM;
  para.lifter     = DEF_CEPLIF;
  para.delWin     = DEF_DELWIN;
  para.silFloor   = DEF_SILFLOOR;
  /* para.escale     = DEF_ESCALE; */
  para.escale     = 1.0;
  para.fbank_num  = DEF_FBANK;
  /* para.cmn        = FALSE;*/
  para.cmn        = TRUE;
  para.enormal    = FALSE;
  para.raw_e      = FALSE;

  para.vec_num = (para.mfcc_dim + 1) * 2;

  framenum = (int)((speechlen - para.framesize) / para.frameshift) + 1;

  param = new_param();
  param->parvec = (VECT **)mymalloc(sizeof(VECT *) * framenum);
  for(i=0;i<framenum;i++) {
    param->parvec[i] = (VECT *)mymalloc(sizeof(VECT) * para.vec_num);
  }
  /* needs conversion here if intergerized */
  Wav2MFCC_E_D(speech, param->parvec, para, speechlen);
  
  param->header.samplenum = framenum;
  param->header.wshift = 100000; /* 16khz */
  param->header.sampsize = para.vec_num * sizeof(VECT); /* not compressed */
  param->header.samptype = F_MFCC | F_ENERGY | F_DELTA | F_CEPNORM;
  param->veclen = para.vec_num;
  param->samplenum = framenum;

  return param;
}

