/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* adin.h */

#ifndef __SENT_ADIN__
#define __SENT_ADIN__

#include <sent/stddefs.h>
#include <sent/speech.h>

/* adin/adin_mic_*.c */
boolean adin_mic_standby();
boolean adin_mic_start();
boolean adin_mic_stop();
int adin_mic_read(SP16 *buf, int sampnum);
/* adin/adin_netaudio.c  and adin/adin_na.c */
boolean adin_netaudio_standby(char *netdevname);
boolean adin_netaudio_start();
boolean adin_netaudio_stop();
int adin_netaudio_read(SP16 *buf, int sampnum);
int NA_standby(char *);
void NA_start();
void NA_stop();
int NA_read(SP16 *buf, int sampnum);

/* adin/adin-cut.c */
void adin_setup_adfunc(
		       boolean (*ad_start)(),
		       boolean (*ad_stop)(),
		       int (*ad_read)(SP16 *, int),
		       int thres
		       );
boolean adin_cut(boolean (*ad_process)(SP16 *, int), boolean strip_flag);

#ifdef HAVE_PTHREAD
typedef struct {		/* datas passed to adin thread */
  SP16 *speech;			/* shared speech sample */
  int *len;			/* shared speech len */
  int maxlen;			/* maximum length of above */
  boolean stflag;		/* stripping on/off */
  boolean *tflag;		/* shared flag for timing tranfer */
} ADIN_THREAD_P;
void adin_cut_thread(ADIN_THREAD_P *);
#endif

/* adin/zc-e.c */
void init_count_zc_e(int c_trigger, int c_length, int c_offset);
void end_count_zc_e();
int count_zc_e(SP16 *buf,int step);
int count_zc_e_level(SP16 *buf,int step,int *levelp);

/* adin/zmean.c */
void sub_zmean(SP16 *speech, int samplenum);


#endif /* __SENT_ADIN__ */
