/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

#ifndef __SENT_GAUSSIAN_PRUNE__
#define __SENT_GAUSSIAN_PRUNE__

enum{GPRUNE_SEL_SAFE, GPRUNE_SEL_HEURISTIC, GPRUNE_SEL_BEAM};

/* Gaussian prob. cache */
typedef struct __mixcache__ {
  LOGPROB score;		/* cached prob. */
  unsigned short id;		/* Gaussian ID in the codebook */
} MIXCACHE;

#define TMBEAMWIDTH 5.0		/* score offset for Gprune=beam */

/* outprob_tm_safe.c  */
void mixture_cache_init_safe(HTK_HMM_INFO *hmminfo, int max_n);
void mixture_cache_prepare_safe(int framenum);
void calc_all_mixtures_and_cache_safe(int t, HTK_Param *param, HTK_HMM_INFO *hmminfo);

/* outprob_tm_heu.c  */
void mixture_cache_init_heuristic(HTK_HMM_INFO *hmminfo, int max_n);
void mixture_cache_prepare_heuristic(int framenum);
void calc_all_mixtures_and_cache_heuristic(int t, HTK_Param *param, HTK_HMM_INFO *hmminfo);

/* outprob_tm_beam.c  */
void mixture_cache_init_beam(HTK_HMM_INFO *hmminfo, int max_n);
void mixture_cache_prepare_beam(int framenum);
void calc_all_mixtures_and_cache_beam(int t, HTK_Param *param, HTK_HMM_INFO *hmminfo);

#endif /*__SENT_GAUSSIAN_PRUNE__*/
