/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* hmm.h --- Hidden Marcov Model structure for recognition */
/* ref: wchmm.h */

/* $Id: hmm.h,v 1.1.1.1 1998/07/16 07:40:26 ri Exp $ */

#ifndef __SENT_HMM_NEW2_H__
#define __SENT_HMM_NEW2_H__

#include <sent/stddefs.h>
#include <sent/htk_hmm.h>
#include <sent/htk_param.h>

/* transition arc data */
typedef struct __a_cell__ {
  LOGPROB		a;	/* transition logprob */
  int			arc;	/* transition destination */
  struct __a_cell__	*next;
} A_CELL;

typedef struct __hmm_state__ {
  A_CELL		*ac;	/* transition arc info (list) */
  HTK_HMM_State		*out;	/* outprob info */
} HMM_STATE;

typedef struct __hmm__ {
  int			len;	/* total state length */
  HMM_STATE		*state;	/* state array */
  LOGPROB		accept_ac_a; /* trans prob to "accept state" */
} HMM;


/* in mkwhmm.c */
HMM *new_make_word_hmm(HTK_HMM_INFO *, HMM_Logical  **, int);
HMM *new_make_word_hmm_with_lm(HTK_HMM_INFO *, HMM_Logical  **, int, LOGPROB *);
void free_hmm(HMM *);
/* in outprob.c */
void make_log_tbl();
LOGPROB addlog(LOGPROB x, LOGPROB y);
LOGPROB addlog_array(LOGPROB *x, int n);
LOGPROB calc_contprob(HTK_HMM_Dens *binfo, VECT *vec, short veclen);
LOGPROB calc_outprob(HTK_HMM_State *, VECT *, short); /* simple calc */
LOGPROB calc_outprob_tm(int t, HTK_HMM_State *stateinfo);
     
/* in outprob_cache.c */
void outprob_init(HTK_HMM_INFO *);
void outprob_cache_prepare(int);
void outprob_cache_clear(int);
LOGPROB outprob_ss(int, HTK_HMM_State *, HTK_Param *); /* cache included */
LOGPROB outprob_tm(int, HTK_HMM_State *, HTK_Param *); /* cache included */

/* vsegment.c */
LOGPROB viterbi_segment(HMM *hmm, HTK_Param *param, int *endstates, int ulen, int *seg_ret, LOGPROB *uscore_ret, LOGPROB (*myoutprob)(int t, HTK_HMM_State *hmm, HTK_Param *p));

/* hmminfo/put_htkdata_info */
void put_hmm_arc(HMM *d);
void put_hmm_outprob(HMM *d);
void put_hmm(HMM *d);

#endif /* __SENT_HMM_NEW2_H__ */
