/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* standard defines (independent from sentence recognition)*/

/* $Id: stddefs.h,v 1.2 1998/09/01 05:19:26 ri Exp $ */

#ifndef __SENT_STANDARD_DEFS__
#define __SENT_STANDARD_DEFS__

/* assertion */
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <sent/machines.h>

#if !defined(PI)
#define PI 3.14159265358979
#endif
#if !defined(TPI)
#define TPI 6.28318530717959
#define LOGTPI 1.83787706640935
#endif

/* define boolean */
typedef unsigned char boolean;
#define TRUE 1
#define FALSE 0

/* some macros */
#define	max(A,B)	((A)>=(B)?(A):(B))
#define	min(A,B)	((A)<(B)?(A):(B))
#define	abs(X)		((X)>0?(X):-(X))
#define strmatch	!strcmp
#define strnmatch	!strncmp
#define DELM " \t\n"

/* from ~speech/src/sent/sentence.h */
#define	LOG_ZERO	-1000000 /* $B$3$l$rJQ99$7$?$i!$K:$l$:(BLOG_ADDMIN$B$bJQ99$9$k$3$H!*(B */
#define LOG_ADDMIN	-13.815510558	/* -log(-LOG_ZERO) (see lib/phmm/outprob.c for explanation) */

/* typedef and enum */
enum LogOutputLevel {
  LOG_NORMAL,
  LOG_VERBOSE,
  LOG_DEBUG
};
enum{DIR_LR, DIR_RL};		/* $B7W;;J}8~(B */

/* you can't use double type for typedefs below */
/* also look at lib/util/mybmalloc.c */
typedef float PROB;		/* $B3NN((B */
typedef float LOGPROB;		/* $B3NN($NBP?tCM(B($B%9%3%"(B) */
typedef int FREQ;		/* $BIQEY$N7?(B */
typedef short SP16;		/* 16bit speech data type */
typedef float VECT;		/* vector element */

/* word num defines */
#ifdef WORDS_INT
  /* 2G = 2^31 mode */
  typedef int WORD_ID; /* $BC18l$N(BID */
  #define MAX_WORD_NUM 2147483647 /* limit size of vocabulary */
  #define WORD_INVALID 2147483647 /* $B!VC18l0J30!W$rI=$9(BID($BC18lHV9f$H=E$J$i$J$$CM(B) */
#elif WORDS_32K
  /* 32k */
  typedef short WORD_ID; /* $BC18l$N(BID */
  #define MAX_WORD_NUM 32767	/* limit size of vocabulary */
  #define WORD_INVALID 32767	/* $B!VC18l0J30!W$rI=$9(BID($BC18lHV9f$H=E$J$i$J$$CM(B) */
#else  /* 64K */
  typedef unsigned short WORD_ID; /* $BC18l$N(BID */
  #define MAX_WORD_NUM 65535	/* limit size of vocabulary */
  #define WORD_INVALID 65535	/* $B!VC18l0J30!W$rI=$9(BID($BC18lHV9f$H=E$J$i$J$$CM(B) */
#endif

#include <sent/util.h>

#endif /* __SENT_STANDARD_DEFS__ */
