/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* defines for TCP/IP commication for each server */
/* original from ~speech/src/sent/tcpip.h */

/* $Id: tcpip.h,v 1.1.1.1 1998/07/16 07:41:52 ri Exp $ */

#ifndef __SENT_SPEECH_TCPIP__
#define __SENT_SPEECH_TCPIP__

#include	<errno.h>
#include	<netdb.h>
#include	<sys/file.h>
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<sys/un.h>
#include	<fcntl.h>
#include	<arpa/inet.h>

#define		AZ_S_PORT_NUM 5501	/* analize server */
#define		CL_S_PORT_NUM 5502	/* classifier server */
#define		WD_S_PORT_NUM 5503  /* word recognition server */
#define		AD_S_PORT_NUM 5504	/* ad-in server */
#define		SR_S_PORT_NUM 5505	/* srconv server */
#define		DM_PORT_NUM   5506 /* dialog manager */
#define		AZ_CL_PORT_NUM 5521	/* analyze server(pipe) */
#define		CL_SP_PORT_NUM 5522	/* classifier server(pipe) */
#define		BT_SP_PORT_NUM 5523 /* backtrellis maker server(pipe) */
#define         FACE_PORT_NUM 5524      /* face server */
/*#define		AD_AZ_M_PORT_NUM 5530 *//* adinm -> azlpcm */
#define         ADINNET_PORT 5530
#define		AZ_CL_M_PORT_NUM 5531 /* azlpcm -> peclm */
#define		CL_ST_M_PORT_NUM 5532 /* peclm -> sentence */
#define		GRAM_S_PORT_NUM 5533 /* grammar server <-> sentrecg */

#define		CONNECTION_RETRY_INTERVAL 5 /* sec. */
#define		CONNECTION_RETRY_TIMES    10 /* retry times */

/* net/dialog.c (bogus) */
void dm_connect(char *hostname);
void dm_send_sentence(WORD_ID words[], short num);
int  dm_receive_ack();
/* net/rdwt.c */
int rd(int fd, char *data, int *len, int maxlen);
int wt(int fd, char *data, int len);
/* net/server_client.c */
int ready_as_server(int port_num);
int ready_as_server_nonblock(int port_num);
int accept_from(int sd);
int make_connection(char *hostname, int port_num);
int make_connection_unix(char *address);

#endif /* __SENT_SPEECH_TCPIP__ */
