/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* util.h ... misc. utility functions in util/ */

#ifndef __SENT_UTIL_H__
#define __SENT_UTIL_H__

/*
 *  Memory block size for mybmalloc() in bytes.
 *  mybmalloc does allocate memory per big block, though cannot free.
 *  It's for reading in large data (i.e. models).
 */
#define MYBMALLOC_BLOCK_SIZE 10000

/* readfile.c */
char *getl(char *, int, FILE *);
char *first_token(char *);
char *next_token(void);
char *next_token_if_any(void);
char *rest_token(void);

/* gzfile.c */
FILE *fopen_readfile(char *);
int fclose_readfile(FILE *);
FILE *fopen_writefile(char *);
int fclose_writefile(FILE *);
size_t myfread(void *ptr, size_t size, size_t n, FILE *fp);
size_t myfwrite(void *ptr, size_t size, size_t n, FILE *fp);

/* mybmalloc.c */
void mybmalloc_set_param();
void *mybmalloc(int);
char *mybstrdup(char *);

/* mymalloc.c */
void *mymalloc(int);
void *myrealloc(void *, int);
void *mycalloc(int, int);
void **malloc_array(int size1, int size2, int elmsize);
void free_array(void **p);

/* endian.c */
void swap_sample_bytes(short *buf, int len);
void swap_bytes(char *buf, size_t unitbyte, int unitnum);

/* j_printf.c */
#include <stdarg.h>
int j_printf(char *format, ...);
int j_printerr(char *format, ...);
int j_flushprint();

/* mystrtok.c */
char *mystrtok_quote(char *str);

#endif /* __SENT_UTIL_H__ */
