/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* defines for vocabulary */

/* $Id: vocabulary.h,v 1.3 1998/09/02 15:47:02 ri Exp $ */

#ifndef __SENT_VOCA_H__
#define __SENT_VOCA_H__

#include <sent/stddefs.h>
#include <sent/htk_hmm.h>

/* original from ~speech/src/sent/hmm.h */
#define	MAXWSTEP 4000		/* step size of vocabulary */

/* Vocabulary information */
typedef struct word_info {
  WORD_ID	maxnum;		/* ($B3d$jIU$1$i$l$?(B)$B:GBgC18l?t(B */
  WORD_ID	num;		/* $BC18l?t(B */
  unsigned char	*wlen;	/* $BC18l$N2;AG?t(B * num */
  char		**wname;	/* $BC18lI=5-J8;zNs(B * num */
  char		**woutput;	/* $B=PNOJ8;zNs(B * num */
  /*  HTK_HMM_Data	***wseq;	$B3FC18l$N3F2;AG$KBP1~$9$k(BHMM$B>pJs$X$N%]%$%s%?(B * num */
  HMM_Logical   ***wseq;	/* $B3FC18l$N3F2;AG$KBP1~$9$k(BHMM$B>pJs$X$N%]%$%s%?(B * num */
  WORD_ID	*wton;		/* N-gram$B>e$NC18l(BID,$B$b$7$/$O%?!<%_%J%kHV9f$H$NBP1~(B * num */
  WORD_ID	head_silwid;	/* $BH/OC@hF,$NL52;C18l$N(BID */
  WORD_ID	tail_silwid;	/* $BH/OC=*C<$NL52;C18l$N(BID */
  short		maxwn;		/* 1$BC18l$"$?$j$N<B<A>uBV?t$N:GBgCM(B */
  short         maxwlen;	/* wlen $B$N:GBgCM(B */
} WORD_INFO;


void winfo_init(WORD_INFO *winfo);
void winfo_expand(WORD_INFO *winfo);
void init_voca(WORD_INFO *winfo, char *filename, HTK_HMM_INFO *hmminfo, boolean);
boolean voca_load_htkdict(FILE *, WORD_INFO *, HTK_HMM_INFO *, boolean);
boolean voca_mono2tri(WORD_INFO *winfo, HTK_HMM_INFO *hmminfo);
WORD_ID voca_lookup_wid(char *, WORD_INFO *);
WORD_ID *new_str2wordseq(WORD_INFO *, char *, int *);
void print_voca_info(WORD_INFO *);

/* CCD ralated */
HTK_HMM_Data **new_make_triphone_seq(WORD_ID wseq[4], int *phlen, WORD_INFO *winfo, HTK_HMM_INFO *hmminfo);
HTK_HMM_Data *get_right_biphone(HTK_HMM_Data *p_base, HTK_HMM_Data *p_modifier, HTK_HMM_INFO *hmminfo);

void put_voca(WORD_INFO *winfo, WORD_ID wid);
void put_voca_err(WORD_INFO *winfo, WORD_ID wid);

#endif /* __SENT_VOCA_H__ */
