/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* adin-netaudio.c --- adin library for NetAudio interface */

/* Tested with DAT deck, DatLink hardware and NetAudio library
   on Solaris2.5.1  */

/* because of `boolean' type conflict in sentlib and datlink includes, */
/* there are only wrappers. The core functions are defined in adin_na.c */

#ifdef USE_NETAUDIO

#include <sent/stddefs.h>
#include <sent/adin.h>

/* check audio port resource and initialize */
/* will be called once at startup time */
boolean
adin_netaudio_standby(char *server_devname)
{
  if (NA_standby(server_devname) == 0) return(FALSE); /* error */
  return(TRUE);
}

/* start recording */
boolean
adin_netaudio_start()
{
  NA_start();
  return(TRUE);
}

/* stop recording */
boolean
adin_netaudio_stop()
{
  NA_stop();
  return(TRUE);
}

/* read samples from audio device */
/* try to read `sampnum' samples and returns actual sample num recorded */
int
adin_netaudio_read(SP16 *buf, int sampnum)
{
  return(NA_read(buf, sampnum));
}

#endif /* USE_NETAUDIO */
