/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* cdhmm.c ---  context-dependent HMM related functions */

/* $Id: cdhmm.c,v 1.1.1.1 1998/07/16 07:41:55 ri Exp $ */

#include <sent/stddefs.h>
#include <sent/htk_hmm.h>

void
add_right_context(char name[], char *rc)
{
  char *p;
  int i;

  if ((p = strchr(name, HMM_RC_DLIM_C)) != NULL) {
    p++;
    *p = '\0';
  } else {
    strcat(name, HMM_RC_DLIM);
  }
  i = strlen(name);
  center_name(rc, &(name[i]));
}
void
add_left_context(char name[], char *lc)
{
  char *p;
  char buf[40];

  if ((p = strchr(name, HMM_LC_DLIM_C)) != NULL) {
    p++;
  } else {
    p = name;
  }
  center_name(lc, buf);
  strcat(buf, HMM_LC_DLIM);
  strcat(buf, p);
  strcpy(name, buf);
}

static char gbuf[40];

/* base$B$r85$H$7(B right context $B$,(B rc $B$G$"$k(BHMM$B$N9=B$BN$X$N%]%$%s%?$rJV$9(B */
/* $B8+$D$+$i$J$$>l9g$O%(%i!<(B $B!D$K$7$?$$$,(B,$B:#$O85$N$rJV$9(B*/
HMM_Logical *
get_right_context_HMM(HMM_Logical *base, HMM_Logical *rc, HTK_HMM_INFO *hmminfo)
{
  HMM_Logical *ret;

  strcpy(gbuf, base->name);
  add_right_context(gbuf, rc->name);
  if ((ret = htk_hmmdata_lookup_logical(hmminfo, gbuf)) == NULL) {
    /* not found */
    /*j_printerr("Warning: get_right_context_HMM: HMM \"%s\" not found\n", gbuf);*/
    ret = base;
  }
  return(ret);
}

/* base$B$r85$H$7(B left context $B$,(B lc $B$G$"$k(BHMM$B$N9=B$BN$X$N%]%$%s%?$rJV$9(B */
/* $B8+$D$+$i$J$$>l9g$O%(%i!<(B $B!D$K$7$?$$$,(B,$B:#$O85$N$rJV$9(B*/
HMM_Logical *
get_left_context_HMM(HMM_Logical *base, HMM_Logical *lc, HTK_HMM_INFO *hmminfo)
{
  HMM_Logical *ret;

  strcpy(gbuf, base->name);
  add_left_context(gbuf, lc->name);
  if ((ret = htk_hmmdata_lookup_logical(hmminfo, gbuf)) == NULL) {
    /* not found */
    /*j_printerr("Warning: get_left_context_HMM: HMM \"%s\" not found\n", gbuf);*/
    ret = base;
  }
  return(ret);
}
  
/* HMM$BL>$+$i(B center $B$rJV$9(B */

char *
center_name(char *hmmname, char *buf)
{
  char *p, *s, *d;

  p = hmmname;
  d = buf;

  /* move next to '-' */
  while (*p != HMM_LC_DLIM_C && *p != '\0') p++;
  if (*p == '\0') s = hmmname;
  else s = ++p;

  while (*s != HMM_RC_DLIM_C && *s != '\0') {
    *d = *s;
    d++;
    s++;
  }
  *d = '\0';

  return (buf);
}

/* HMM$BL>$+$i(B left+center $B$rJV$9(B */
char *
leftcenter_name(char *hmmname, char *buf)
{
  char *p;
  /* strip off "+..." */
  strcpy(buf,hmmname);
  if ((p = strchr(buf, HMM_RC_DLIM_C)) != NULL) {
    *p = '\0';
  }
  return(buf);
}
