/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* guess_cdHMM.c --- guess whether hmminfo is context-dependent model by naming rule */

/* $Id: guess_cdHMM.c,v 1.1.1.1 1998/07/16 07:41:55 ri Exp $ */

#include <sent/stddefs.h>
#include <sent/htk_hmm.h>

boolean
guess_if_cd_hmm(HTK_HMM_INFO *hmminfo)
{
  HMM_Logical *dt;
  int rnum, lnum, totalnum;

  /* $BH=JL4p=`(B: logical $B$K(B HMM_RC_DLIM, HMM_LC_DLIM $B$r4^$`L>A0$,$"$k$+(B */
  /* (physical $B$O4{$K(B logical $B$K4^$^$l$F$$$k(B)  */
  rnum = lnum = totalnum = 0;
  for (dt = hmminfo->lgstart; dt; dt = dt->next) {
    if (strstr(dt->name, HMM_RC_DLIM) != NULL) rnum++;
    if (strstr(dt->name, HMM_LC_DLIM) != NULL) lnum++;
    totalnum++;
  }
  if (rnum > 0) {
    if (lnum == 0) {
      j_printerr("Warning: cannot handle right-context dependency correctly\n");
      return(FALSE);
    } else {
      return(TRUE);
    }
  }
  return(FALSE);
}
