/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/*
** dialog.c --- communicate with dialog manager (bogus)
**
*/

/* $Id: dialog.c,v 1.1.1.1 1998/07/16 07:41:57 ri Exp $ */

#include <sent/stddefs.h>
#include <sent/tcpip.h>

/* $B%=%1%C%H(B */
static int sock;

/* $B@\B3$7$?$+$I$&$+(B */
static int connect_flag = FALSE;

/* dialog manager $B$H$N@\B3$r3NN)$9$k(B */
void
dm_connect(char *hostname)
{
  struct sockaddr_in dm;
  struct hostent *host;

  memset((char *)&dm, 0, sizeof(dm));
  dm.sin_family = AF_INET;
  dm.sin_port = DM_PORT_NUM;
  if ((host = gethostbyname(hostname)) == NULL)
    {
      j_printerr("%s: unknown host\n",hostname);
      exit(1);
    }
  memcpy(&dm.sin_addr, host->h_addr, host->h_length);
  if ((sock = socket(PF_INET, SOCK_STREAM, 0)) == -1)
    {
      j_printerr("Can't create socket\n");
      exit(1);
    }
  if (connect(sock, (struct sockaddr *)&dm, sizeof(dm)) == -1)
    {
      j_printerr("Can't connect to %s\n",hostname);
      exit(1);
    }
  connect_flag = TRUE;
}

/* $BBPOC4IM}It$KJ82>@b$rAw$k(B */
/* $BC18lHV9f$GEO$9(B */
void
dm_send_sentence(WORD_ID words[], short num)
{
  int nbyte;
  if (!connect_flag)
    {
      j_printerr( "Connection hasn't established yet.\n");
      exit(1);
    }
  nbyte = num * sizeof(WORD_ID);
  if (write(sock, words, nbyte) != nbyte)
    {
      j_printerr("Failed to write to socket.\n");
      exit(1);
    }
}
      
      
/* $BBPOC4IM}It$+$i(B ACKNOWLEDGE $B$r<u$1<h$k(B */
int				/* $BJV$jCM(B = acknowledge */
dm_receive_ack()
{
  int ack;
  int nbyte;
  if (!connect_flag)
    {
      j_printerr( "Connection hasn't established yet.\n");
      return -1;
    }
  nbyte = sizeof(int);
  if (read(sock, &ack, nbyte) != nbyte)
    {
      j_printerr("Failed to write to socket.\n");
      return -1;
    }
  return(ack);
}
