/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/*
** rdwt.c --- interprocess communication lowlevel functions
**
*/

/* $Id: rdwt.c,v 1.1.1.1 1998/07/16 07:41:57 ri Exp $ */

#include <sent/stddefs.h>
#include <sent/tcpip.h>

/* $BDL?.%P%C%U%!%5%$%:(B */
#define		BUFSZ	4096
/* $B$=$NB>%^%/%m(B */


int
rd(  int   fd,			/* $B%U%!%$%k%G%9%/%j%W%?(B */
     char *data,		/* $B<u?.%G!<%?3JG<%P%C%U%!$X$N%]%$%s%?(B */
     int  *len,			/* $B<u?.$5$l$?%G!<%?D9(B(byte) */
     int   maxlen)		/* $B3JG<%P%C%U%!$N:GBgD9(B(byte) */
{
  int count=0;
  int tmpbytes, tmplen;
  
  if ((tmpbytes=read(fd,(char *)len,sizeof(int))) != sizeof(int)) {
    /*j_printerr( "failed to read num\n");*/
    return(-1);
  }
  if (*len > maxlen) {
    j_printerr( "transfer data length exceeded: %d (>%d)\n",
	    len, maxlen);
    return(-1);
  }
  while (count<(*len)){

    tmplen = (*len) - count;
    if (tmplen > BUFSZ) tmplen = BUFSZ;
    if ((tmpbytes = read(fd,data+count,tmplen)) < 0) {
      j_printerr( "failed to read data at %d / %d\n",count, len);
      return(count);
    }
    count += tmpbytes;
  }
  return(count);
}

/* $BDL?.MQ(BRAW$B4X?t(B($B=q$-=P$7(B) */
int
wt(
   int  fd,			/* $B%U%!%$%k%G%9%/%j%W%?(B */
   char *data,			/* $BAw?.%G!<%?3JG<%P%C%U%!$X$N%]%$%s%?(B */
   int   len)			/* $BAw?.%G!<%?D9(B(byte) */
{
  int	tmpbytes;
  
  if ((tmpbytes=write(fd,(char *)&len,sizeof(int))) != sizeof(int)) {
    /*j_printerr( "failed to write num\n");*/
    return(-1);
  }
  if (len > 0) {
    if ((tmpbytes=write(fd,data,len)) < 0) {
      j_printerr( "failed to write data (%d bytes)\n",len);
      return(-1);
    }
  } else {
    tmpbytes = 0;
  }
  return(tmpbytes);
}
