/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* ngram_lookup.c --- word -> id lookup functions */

/* $Id: ngram_lookup.c,v 1.1.1.1 1998/07/16 07:41:58 ri Exp $ */

#include <sent/stddefs.h>
#include <sent/ngram2.h>
#include <sent/ptree.h>


/* ndata->wname $B$+$i!$C18lL>(B -> id $B8!:wMQ%D%j!<$r:n$k(B */
void
ngram_make_lookup_tree(NGRAM_INFO *ndata)
{
  int i;
  int *windex;
  char **wnameindex;
  
  windex = (int *)mymalloc(sizeof(int)*ndata->max_word_num);
  for (i=0;i<ndata->max_word_num;i++) {
    windex[i] = i;
  }
  wnameindex = (char **)mymalloc(sizeof(char *)*ndata->max_word_num);
  for (i=0;i<ndata->max_word_num;i++) {
    wnameindex[i] = ndata->wname[i];
  }

  ndata->root = make_ptree(wnameindex, windex, ndata->max_word_num, 0);

  free(windex);
  free(wnameindex);
}

WORD_ID
ngram_lookup_word(NGRAM_INFO *ndata, char *wordstr)
{
  int data;
  data = ptree_search_data(wordstr, ndata->root);
  if (strcmp(wordstr, ndata->wname[data]) != 0) {
    return WORD_INVALID;
  } else {
    return(data);
  }
}

/* word name -> word id $B$rJV$9(B($B%=!<%H$5$l$F$kI,MW$J$7!$CY$$$,3N<B(B) */
WORD_ID
make_ngram_ref(NGRAM_INFO *ndata, char *wstr)
{
  WORD_ID nw;

  nw = ngram_lookup_word(ndata, wstr);
  if (nw == WORD_INVALID) {
    /* not found */
    /* treat as unknown word */
    j_printf("word %s not exist in N-gram, treat as <UNK>\n", wstr);
    return(ndata->unk_id);
  } else {
    return(nw);
  }
}
