/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* $Id: mymalloc.c,v 1.1.1.1 1998/07/16 07:42:01 ri Exp $ */

#include <sent/stddefs.h>


/* generic allocations with error trap */
void *
mymalloc(int size)
{
  void *p;
  if ( (p = malloc(size)) == NULL) {
    j_printerr("cannot malloc %d byte\n",size);
    exit(1);
  }
  return p;
}

void *
myrealloc(void *ptr, int size)
{
  void *p;
  if ( (p = realloc(ptr,size)) == NULL) {
    j_printerr("cannot realloc %d byte\n",size);
    exit(1);
  }
  return p;
}
void *
mycalloc(int nelem, int elsize)
{
  void *p;
  if ( (p = calloc(nelem,elsize)) == NULL) {
    j_printerr("cannot calloc %d x %d byte\n",nelem, elsize);
    exit(1);
  }
  return p;
}



/* sequancially allocate [size1][size2] array */
/* will sequencially allocate [n][0] - [n][size2-1] */
void **
malloc_array(
     int size1,			/* size of 1st axis */
     int size2,			/* size of 2nd axis */
     int elmsize)		/* element size (byte) */
{
  char **p;
  int i;

  p = (char **)mymalloc(sizeof(void *) * size1);
  p[0] = (char *)mymalloc(elmsize * size2 * size1);
  for (i=1;i<size1;i++) {
    p[i] = &(p[0][elmsize * size2 * i]);
  }

  return ((void **)p);
}
void
free_array(void **p)
{
  free(p[0]);
  free(p);
}
