/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

#include <sent/stddefs.h>


/* mystrtok_quote() */
/* string to token with quotation by \" */
/* used for parsing HMMDEF file */

/* specifications:  */
/*   quotation: double-quotation only */
/*   escape: none */
/*   comment out: none */
/*   quotation across line: not handled correctly */
/*   delimiter: [ \t<>] */
/*   given string: will be corrupted after this */
#define ISTOKEN(A) (A == ' ' || A == '\t' || A == '\n' || A == '<' || A == '>')
char  *
mystrtok_quote(char *str)
{
  static char *buf;		/* target string buffer */
  static char *pos;		/* current pointer position */
  char *p;
  char *from, *to;

  if (str != NULL) {
    pos = buf = str;
  }

  /* find start point */
  p = pos;
  while (*p != '\0' && ISTOKEN(*p)) *p++;
  if (*p == '\0') return NULL;	/* no token left */
  
  /* copy to ret_buf until end point is found */
  if (*p == 34) {		/* double-quote */
    p++;
    if (*p == '\0') return NULL;
    from = p;
    while (*p != '\0' && *p != 34) *p++;
    /* if quotation not terminated, allow the rest as one token */
    /* if (*p == '\0') return NULL; */
  } else {
    from = p;
    while (*p != '\0' && (!ISTOKEN(*p))) p++;
  }
  if (*p != '\0') {
    *p = '\0';
    p++;
  }
  pos = p;
  return from;
}

/* mystrtok_special() */
/* string to token with enhancement */
/* mainly for parsing config file */

/* specifications:  */
/*   quotation: double-quotation and single quotation */
/*   escape: by backslash */
/*   comment out: # */
/*   quotation across line: not handled correctly */
/*   delimiter: [ \t] */
/*   given string: will be corrupted after this */
