/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* readfile.c --- file reading utilize functions */

#include <sent/stddefs.h>
#ifdef HAVE_ZLIB
#include <zlib.h>
#endif

/* fp $B$+$i(B buf $B$K0l9TFI$_9~$`!%6u9T$O$H$P$9!%%(%i!<$G(BNULL$B$rJV$9(B */
char *
getl(char *buf, int maxlen, FILE *fp)
{
  int newline;

  while(
#ifdef HAVE_ZLIB
	gzgets((gzFile)fp, buf, maxlen) != Z_NULL
#else
	fgets(buf, maxlen, fp) != NULL
#endif
	) {
    newline = strlen(buf)-1;    /* chop newline */
    if (buf[newline] == '\n') buf[newline] = '\0';
    if (buf[0] == '\0') continue; /* if blank line, read next */
    return buf;
  }
  return NULL;
}

char *
first_token(char *buf)
{
  char *p;
  if ((p=strtok(buf, DELM)) == NULL) {
    j_printerr("data format error: corrupted data?\n");
    exit(1);
  }
  return p;
}
char *
next_token() {
  char *p;
  if ((p=strtok(NULL,DELM)) == NULL) {
    j_printerr("data format error: corrupted data?\n");
    exit(1);
  }
  return p;
}
char *
next_token_if_any() {
  char *p;

  p=strtok(NULL,DELM);

  return p;
}
char *
rest_token() {
  char *p;
  if ((p=strtok(NULL, "\n")) == NULL) {
    j_printerr("data format error: corrupted data?\n");
    exit(1);
  }
  return p;
}    

