/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* init_voca.c --- read in dict file and initialize */

/* $Id: init_voca.c,v 1.1.1.1 1998/07/16 07:42:02 ri Exp $ */

#include <sent/stddefs.h>
#include <sent/htk_hmm.h>
#include <sent/vocabulary.h>

/* read & initialize dict */
void
init_voca(WORD_INFO *winfo, char *filename, HTK_HMM_INFO *hmminfo, boolean not_conv_tri)
{
  FILE *fd;

  j_printerr("Reading in dictionary...");
  /* read voca file */
  if ((fd = fopen_readfile(filename)) == NULL) {
    j_printerr("failed to open %s\n",filename);
    exit(1);
  }
  /* voca$BFI$_9~$_(B(HTK dict$B%U%)!<%^%C%HMQ(B) */
  if (!voca_load_htkdict(fd, winfo, hmminfo, not_conv_tri)) {
    j_printerr("error in reading %s\n",filename);
    exit(1);
  }
  if (fclose_readfile(fd) == -1) {
    j_printerr("close error\n");
    exit(1);
  }

  j_printerr("%d words...done\n", winfo->num);
}
