/* Copyright (c) 1991-2000 Doshita Lab. Speech Group, Kyoto University */
/*   All rights reserved   */

/* voca_util.c -- voabulary (dictionary) related utility functions */

/* $Id: voca_util.c,v 1.1.1.1 1998/07/16 07:42:02 ri Exp $ */

#include <sent/stddefs.h>
#include <sent/vocabulary.h>

/* output vocabulary info */
void
print_voca_info(WORD_INFO *winfo)
{
  int i,j;
  long models, states;

  models = 0;
  states = 0;
  for (i=0;i<winfo->num;i++) {
    models += winfo->wlen[i];
    for (j=0;j<winfo->wlen[i];j++) {
      states += (winfo->wseq[i][j])->def->state_num - 2;
    }
  }

  j_printf("Dictionary Info:\n");
  j_printf("        vocabulary size  = %d words, %d models, %d states\n", winfo->num, models, states);
  j_printf("        average word len = %.1f models, %.1f states\n", (float)models/(float)winfo->num, (float)states/(float)winfo->num);
  j_printf("       maximum state num = %d nodes per word\n", winfo->maxwn);
}
	 
/* output voca info string */
void
put_voca(WORD_INFO *winfo, WORD_ID wid)
{
  int i;
  j_printf("%d: %s [%s]", wid, winfo->wname[wid], winfo->woutput[wid]);
  for(i=0;i<winfo->wlen[wid];i++) {
    j_printf(" %s(%s)", winfo->wseq[wid][i]->name, winfo->wseq[wid][i]->def->name);
  }
  j_printf("\n");
}
void
put_voca_err(WORD_INFO *winfo, WORD_ID wid)
{
  int i;
  j_printerr("id%d: %s [%s]", wid, winfo->wname[wid], winfo->woutput[wid]);
  for(i=0;i<winfo->wlen[wid];i++) {
    j_printerr(" %s(%s)", winfo->wseq[wid][i]->name, winfo->wseq[wid][i]->def->name);
  }
  j_printerr("\n");
}
